Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.value
Class MemoClosure

    java.lang.Object
      net.sf.saxon.value.Value
          net.sf.saxon.value.Closure
              net.sf.saxon.value.MemoClosure

All Implemented Interfaces:
  Expression, java.io.Serializable, ValueRepresentation

Direct Known Subclasses:
  IndexedClosure

public class MemoClosure
extends Closure

A MemoClosure represents a value that has not yet been evaluated: the value is represented by an expression, together with saved values of all the context variables that the expression depends on.

The MemoClosure is designed for use when the value is only read several times. The value is saved on the first evaluation and remembered for later use.

The MemoClosure maintains a reservoir containing those items in the value that have already been read. When a new iterator is requested to read the value, this iterator first examines and returns any items already placed in the reservoir by previous users of the MemoClosure. When the reservoir is exhausted, it then uses an underlying Input Iterator to read further values of the underlying expression. If the value is not read to completion (for example, if the first user did exists($expr), then the Input Iterator is left positioned where this user abandoned it. The next user will read any values left in the reservoir by the first user, and then pick up iterating the base expression where the first user left off. Eventually, all the values of the expression will find their way into the reservoir, and future users simply iterate over the reservoir contents. Alternatively, of course, the values may be left unread.

Delayed evaluation is used only for expressions with a static type that allows more than one item, so the evaluateItem() method will not normally be used, but it is supported for completeness.

The expression may depend on local variables and on the context item; these values are held in the saved XPathContext object that is kept as part of the Closure, and they will always be read from that object. The expression may also depend on global variables; these are unchanging, so they can be read from the Bindery in the normal way. Expressions that depend on other contextual information, for example the values of position(), last(), current(), current-group(), should not be evaluated using this mechanism: they should always be evaluated eagerly. This means that the Closure does not need to keep a copy of these context variables.

See Also:
  Serialized Form

Nested Class Summary
`class` | `MemoClosure.ProgressiveIterator` A ProgressiveIterator starts by reading any items already held in the reservoir; when the reservoir is exhausted, it reads further items from the inputIterator, copying them into the reservoir as they are read.

Field Summary
`protected static int` | `EMPTY`
`protected int` | `state`

Fields inherited from class net.sf.saxon.value.Closure
`depth, expression, inputIterator, savedXPathContext`

Fields inherited from class net.sf.saxon.value.Value
`EMPTY_CLASS_ARRAY`

Fields inherited from interface net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Constructor Summary
`MemoClosure()` Constructor should not be called directly, instances should be made using the make() method.

Method Summary
`int` | `getLength()` Get the length of the sequence
`boolean` | `isFullyRead()` Determine whether the contents of the MemoClosure have been fully read
`Item` | `itemAt(int n)` Get the n'th item in the sequence (starting from 0).
`SequenceIterator` | `iterate(XPathContext context)` Evaluate the expression in a given context to return an iterator over a sequence
`Value` | `materialize()` Return a value containing all the items in the sequence returned by this SequenceIterator
`void` | `process(XPathContext context)` Process the instruction, without returning any tail calls

Methods inherited from class net.sf.saxon.value.Closure
`display, getCardinality, getImplementationMethod, getItemType, getSpecialProperties, isIndexable, make, makeIteratorClosure, reduce`

Methods inherited from class net.sf.saxon.value.Value
`asItem, asIterator, asValue, checkPermittedContents, collapseWhitespace, convert, convertJavaObjectToXPath, convertToJava, effectiveBooleanValue, equals, evaluateAsString, evaluateItem, getDependencies, getIterator, getParentExpression, getStringValue, hashCode, iterateSubExpressions, makeQNameValue, normalizeWhitespace, optimize, promote, schemaEquals, simplify, stringToNumber, toString, trimWhitespace, typeCheck`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### state

    protected int state

### EMPTY

    protected static final int EMPTY

See Also:
  Constant Field Values

Constructor Detail

### MemoClosure

    public MemoClosure()

  Constructor should not be called directly, instances should be made using the make() method.

Method Detail

### iterate

    public SequenceIterator iterate(XPathContext context)
                             throws XPathException

  Evaluate the expression in a given context to return an iterator over a sequence

  Specified by:
    `iterate` in interface `Expression`
  Overrides:
    `iterate` in class `Closure`
  Parameters:
    `context` - the evaluation context. This is ignored; we use the context saved as part of the Closure instead.
  Throws:
    `XPathException`

### process

    public void process(XPathContext context)
                 throws XPathException

  Process the instruction, without returning any tail calls

  Specified by:
    `process` in interface `Expression`
  Overrides:
    `process` in class `Closure`
  Parameters:
    `context` - The dynamic context, giving access to the current node, the current variables, etc.
  Throws:
    `XPathException`

### itemAt

    public Item itemAt(int n)
                throws XPathException

  Get the n'th item in the sequence (starting from 0). This is defined for all SequenceValues, but its real benefits come for a SequenceValue stored extensionally

  Overrides:
    `itemAt` in class `Value`
  Throws:
    `XPathException`

### getLength

    public int getLength()
                  throws XPathException

  Get the length of the sequence

  Overrides:
    `getLength` in class `Value`
  Throws:
    `XPathException`

### isFullyRead

    public boolean isFullyRead()

  Determine whether the contents of the MemoClosure have been fully read

### materialize

    public Value materialize()
                      throws XPathException

  Return a value containing all the items in the sequence returned by this SequenceIterator

  Returns:
    the corresponding value
  Throws:
    `XPathException`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD